use serde::de::DeserializeOwned;
use tauri::{plugin::PluginApi, AppHandle, Runtime};

use crate::models::*;

pub fn init<R: Runtime, C: DeserializeOwned>(
  app: &AppHandle<R>,
  _api: PluginApi<R, C>,
) -> crate::Result<RevenueCat<R>> {
  Ok(RevenueCat(app.clone()))
}

/// Access to the revenue-cat APIs.
pub struct RevenueCat<R: Runtime>(AppHandle<R>);

impl<R: Runtime> RevenueCat<R> {
  pub fn ping(&self, payload: PingRequest) -> crate::Result<PingResponse> {
    Ok(PingResponse {
      value: payload.value,
    })
  }
}
